;----------------------------------------------------------------------------;
; File PreExm6B.ASM *****
;
; This program will do following tasks:
;		- User is required to enter characters from keyboard
;		- User press Enter key to finish, then chars is stored in an array 
;		- Visit the array, if char is a even num then it will be copied to EVEN_NUM array
;		- If it is a add num then copied to ODD_NUM array
;		- Display all elems stored in EVEN_NUM and ODD_NUM, if no elem then send a message
;		- Quit to the DOS
;----------------------------------------------------------------------------;

DOSSEG

.MODEL Small									; Make a *.exe
.STACK 100										; Declare a 100-Byte stack
.DATA
	STRING 		DB	80 DUP(?)				; The array stores input chars
	EVEN_NUM 	DB 80 DUP(?)				; The array stores even number chars
	ODD_NUM 		DB 80 DUP(?)				; The array stores odd number chars
	EVEN_SAM		DB '02468'					; Even number chars
	ODD_SAM		DB '13579'					; Odd number chars
	_Notice1 	DB 0Dh,0Ah,'Number of even numeral chars in the string is: $'	
	_Notice2 	DB 0Dh,0Ah,'Number of odd numeral chars in the string is: $'	
	_NoEvenNum	DB 0Dh,0Ah,'* Message: There is no even num chars! * $'	
	_NoOddNum	DB 0Dh,0Ah,'* Message: There is no odd num chars! * $'	
	Num_Even		DW 0							; Number of elems in the EVEN_NUM, (requied 16 bits)
	Num_Odd		DW 0							; Number of elems in the ODD_NUM, (requied 16 bits)
	Chr_Counter DW 0							; Number of elems in the STRING, (requied 16 bits)

.CODE
	THEMAIN PROC

	MOV 	AX,@DATA								; Prepare data for DS, ES
	MOV 	DS,AX									
	MOV 	ES,AX
	LEA	DI, STRING							; DI points to the STRING[0] (required by INPUT)
	CALL 	INPUT									; Call a sub-program to enter chars 

; ----- visit STRING and copy even num to EVEN_NUM array ----------

	MOV	SI,DI									; SI points to the STRING 
	CLD											; Forward direction for DI and SI

	XOR	BX,BX									; BX=0 
	LEA	BX,EVEN_NUM							; BX points to the EVEN_NUM

Redo1:
	LODSB											; Take an elem in the STRING pointed by SI
	LEA	DI,EVEN_SAM							; DI points to EVEN_SAM
	MOV	CX,5									; To be repeated 5 times, BX requied by REPNE
	REPNE SCASB									; Visit EVEN_SAM, compare to the char pointed by SI?
	JNE	Continue1							; Not an even num char, jump to Continue:
	MOV	[BX],AL								; Be an even num char, copied to EVEN_NUM[i]
	INC	Num_Even								; Num_Even++
	;INC	SI										; 
	INC	BX										; Point to next elem of EVEN_NUM

Continue1:
	DEC	Chr_Counter							; Decrease num of repeated times in the STRING
	JNZ	Redo1									; Not ends of the STRING, redo

; ----- visit STRING and copy even num to ODD_NUM array ----------

	LEA	SI,STRING							; SI points to the STRING 
	CLD											; Forward direction for DI and SI

	XOR	BX,BX									; BX=0 
	LEA	BX,ODD_NUM							; BX points to the ODD_NUM

Redo2:
	LODSB											; Take an elem in the STRING pointed by SI
	LEA	DI,ODD_SAM							; DI points to ODD_SAM
	MOV	CX,5									; To be repeated 5 times, BX requied by REPNE
	REPNE SCASB									; Visit ODD_SAM, compare to the char pointed by SI?
	JNE	Continue2							; Not an ODD num char, jump to Continue:
	MOV	[BX],AL								; Be an ODD num char, copied to ODD_NUM[i]
	INC	Num_Odd								; Num_Odd++
	;INC	SI										; 
	INC	BX										; Point to next elem of ODD_NUM

Continue2:
	DEC	Chr_Counter							; Decrease num of repeated times in the STRING
	JNZ	Redo2									; Not ends of the STRING, redo

;------ Diplay even array ---------

	CMP	Num_Even,0							; Num of even <=0?
	JA		Has_Number1							; If >0 , display elems and num of even chars
	MOV 	AH,9             					; There is no even number in the EVEN_NUM 
   LEA 	DX,_NoEvenNum 
   INT 	21h 
	JMP 	Display_Odd
	
Has_Number1:
	MOV 	AH,9									; Display massage 1
   LEA 	DX,_Notice1  						
   INT  	21h                 				

	MOV	BX,Num_Even							; BX=Num_Even, required by OUTPUT sub-program
	CALL 	OUTPUT								; Display num of elems in EVEN_NUM
	LEA	SI,EVEN_NUM							; point to head of EVEN_NUM

For_Label_1:									;
	XOR	DX,DX
	MOV	DL,[SI]								; current element of EVEN_NUM
	MOV	AH,2									; Display EVEN_NUM[i] on screen
	INT 	21h									; 
	INC	SI										; i++, next element of EVEN_NUM
	DEC	Num_Even								; Num_Even--
	JNZ	For_Label_1							; Repeat if not end of EVEN_NUM (Num_Even>0)  

;------ Diplay odd array ---------

Display_Odd:
	CMP	Num_Odd,0							; Num of even <=0?
	JA		Has_Number2							; If >0 , display elems and num of even chars
	MOV 	AH,9             					; There is no even number in the ODD_NUM 
   LEA 	DX,_NoOddNum 
   INT 	21h 
	JMP 	ExitDOS
	
Has_Number2:
	MOV 	AH,9									; Display massage 2
   LEA 	DX,_Notice2  						
   INT  	21h                 				

	MOV	BX,Num_Odd							; BX=Num_Odd, required by OUTPUT sub-program
	CALL 	OUTPUT								; Display num of elems in ODD_NUM
	LEA	SI,ODD_NUM							; point to head of ODD_NUM

For_Label_2:									;
	XOR	DX,DX
	MOV	DL,[SI]								; current element of ODD_NUM
	MOV	AH,2									; Display ODD_NUM[i] on screen
	INT 	21h									; 
	INC	SI										; i++, next element of ODD_NUM
	DEC	Num_Odd								; Num_Odd--
	JNZ	For_Label_2							; Repeat if not end of ODD_NUM (Num_Odd>0)  

ExitDOS:
	
  	MOV 	AH,4Ch                       	; Exit to DOS
 	INT 	21h

THEMAIN ENDP

; ------------------------------ Sub-Program1 --------------------------------

INPUT PROC 
; Input			: Keyboard 
; Output    	: STRING, DI stores offset adress of the STRING
;					: Chr_Counter stores num of chars in STRING
; Description  : Enter a char from keyboard, stores in STRING array, Press Enter to finish
;
;----------------------------------------------------------------------------- 
.DATA 
   _Mess1    DB 0Dh,0Ah,'* Please enter characters *',0Ah, 0Dh,'$' 

.CODE 
   PUSH 	AX             		; Stores old value of registers 
   PUSH	BX 
	PUSH 	CX 
	PUSH 	DX 
	PUSH	DI
	 
	MOV AH,9             		; Display message 1 
   LEA DX,_Mess1 
   INT 21h 

	CLD								; Forward direction for DI
	XOR	BX,BX						; BX=0, it is a counter of the STRING
	MOV 	AH,1						; Pre-read a char from keyboard

Read_again:
   INT	21h              		; Stores the char in the AL 
   CMP	AL,0Dh           		; Is Enter pressed? 
   JE		Finish	         	; Yes, finish 
	STOSB								; No, stores in STRING aaray
	INC	BX							; Counter++
	JMP	Read_again				; Read next char

Finish:	
	MOV	Chr_Counter,BX			; Chr_Counter stores num of elem in the STRING
   POP   DI               		; Restore old value of registers 
   POP   DX 
   POP   CX 
	POP	BX 
	POP   AX 
 	RET                     	; Return where it is called 

INPUT   ENDP 

; ------------------------------ Sub-Program2 --------------------------------

OUTPUT   PROC
; Input			:  BX
; Output			:  Monitor
; Description	:  Converts value stored in BX to Decimal, the display on Monitor
;-----------------------------------------------------------------------------
	PUSH AX                     			; Stores old value of registers
	;PUSH BX
	PUSH	CX
	PUSH DX


	XOR	CX,CX                         ; Stack pointer, initial value=0
	MOV	AX,BX                         ; AX = value to be displayed (in BX)
	MOV	BX,10                         ; BX=10 is a dividend
	
Push_Repeat:  

	XOR	DX,DX                         ; DX=0 stores remainder
	DIV	BX                            ; AX=AX/10+DX
	INC 	CX                            ; Next elem in the Stack
	PUSH	DX                            ; Push DX (remainder) in the Stack
	CMP 	AX,0                          ; Quotient AX = 0?
	JNZ	Push_Repeat               		; No, continue to divide
	
	MOV	AH, 02								; Pre-display value to Monitor
	
Pop_Repeat:  

	POP	DX                            ; Pop a elem from Stack, store in DX
	ADD	DL, 48                        ; Convert the elem to ASCII(48="0")
	INT  	21h                           ; Display on Monitor
	DEC	CX                            ; Next elem of the Stack
	JNZ  Pop_Repeat                 		; If not empty, pop again
	  
	POP 	DX                           	; Restore old value of registers
	POP 	CX
	;POP 	BX
	POP 	AX
	RET                                	; Return where it is called

	OUTPUT   ENDP
	
END THEMAIN


